package de.duehl.algorithm.backtracking.eightqueens;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import static de.duehl.algorithm.backtracking.eightqueens.Square.*;

public class EightQueensTest {

    @Test
    public void queensWatchEachOtherQueensOnSamePlace() {
        boolean actual = EightQueens.queensWatchEachOther(A1, A1);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherQueensOnSameRank() {
        boolean actual = EightQueens.queensWatchEachOther(A1, H1);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherQueensOnSameFile() {
        boolean actual = EightQueens.queensWatchEachOther(A1, A8);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnA1AndB3() {
        boolean actual = EightQueens.queensWatchEachOther(A1, B3);
        boolean expected = false;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnA1AndC3() {
        boolean actual = EightQueens.queensWatchEachOther(A1, C3);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnA1AndH8() {
        boolean actual = EightQueens.queensWatchEachOther(A1, H8);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnB7AndG2() {
        boolean actual = EightQueens.queensWatchEachOther(B7, G2);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnB7AndH2() {
        boolean actual = EightQueens.queensWatchEachOther(B7, H2);
        boolean expected = false;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnB5AndF1() {
        boolean actual = EightQueens.queensWatchEachOther(B5, F1);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnB5AndE1() {
        boolean actual = EightQueens.queensWatchEachOther(B5, E1);
        boolean expected = false;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnB3AndA1() {
        boolean actual = EightQueens.queensWatchEachOther(B3, A1);
        boolean expected = false;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnC3AndA1() {
        boolean actual = EightQueens.queensWatchEachOther(C3, A1);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnH8AndA1() {
        boolean actual = EightQueens.queensWatchEachOther(H8, A1);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnG2AndB7() {
        boolean actual = EightQueens.queensWatchEachOther(G2, B7);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnH2AndB7() {
        boolean actual = EightQueens.queensWatchEachOther(H2, B7);
        boolean expected = false;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherTrueQueensOnF1AndB5() {
        boolean actual = EightQueens.queensWatchEachOther(F1, B5);
        boolean expected = true;
        assertEquals(expected, actual);
    }

    @Test
    public void queensWatchEachOtherFalseQueensOnE1AndB5() {
        boolean actual = EightQueens.queensWatchEachOther(E1, B5);
        boolean expected = false;
        assertEquals(expected, actual);
    }

}
