package de.duehl.algorithm.backtracking.subsets;


import de.duehl.algorithm.backtracking.Backtracking;
import de.duehl.basics.collections.CollectionsHelper;
import de.duehl.basics.text.NumberString;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

public class SubsetBacktrackingTest {

    @Test
    public void foo() {
        List<List<Integer>> possibleIndices = new ArrayList<>();
        possibleIndices.add(CollectionsHelper.buildListFrom(0, 18));
        possibleIndices.add(CollectionsHelper.buildListFrom(5));
        possibleIndices.add(CollectionsHelper.buildListFrom(12, 42));
        Subset subset = new Subset(possibleIndices);

        Backtracking<Subset, SubsetStep> backtracking = new Backtracking<>();
        backtracking.informAfterXSteps(10);

        boolean hasSolution = backtracking.findSolution(subset);
        assertTrue(hasSolution);
        //printResult(subset, backtracking, hasSolution);
    }

    @SuppressWarnings("unused")
    private void printResult(Subset subset, Backtracking<Subset, SubsetStep> backtracking,
            boolean hasSolution) {
        System.out.println("Anzahl rekursiver Aufrufe      : "
                + NumberString.taupu(backtracking.getRecursiveCount()));
        System.out.println("Anzahl versuchter Schritte     : "
                + NumberString.taupu(backtracking.getTriedStepsCount()));
        System.out.println("Anzahl zurückgenommene Schritte: "
                + NumberString.taupu(backtracking.getBacktrackingCount()));
        System.out.println("Laufzeit                       : " + backtracking.getRuntime());

        if (hasSolution) {
            System.out.println("Lösung:\n" + subset.toString());
        }
        else {
            System.out.println("Es gibt keine Lösung.");
        }
    }

}
