package de.duehl.basics.system;

/*
 * Copyright 2019 Christian Dühl. All rights reserved.
 *
 * This program is free software. You can redistribute it and/or
 * modify it under the same terms as perl:
 *
 * general:  http://dev.perl.org/licenses/
 * GPL:      http://dev.perl.org/licenses/gpl1.html
 * artistic: http://dev.perl.org/licenses/artistic.html
 */

import static org.junit.Assert.*;

import org.junit.Test;

public class SytemToolsTest {

    @Test
    public void determineOperationSystem() {
        OperationSystem os = SystemTools.determineOperationSystem();
        assertNotNull(os);
    }

    @Test
    public void determineOperationSystemRunningWindoes() {
        OperationSystem os = SystemTools.determineOperationSystem();
        assertEquals(OperationSystem.WINDOWS, os);
    }

    @Test
    public void getUserName() {
        String user = SystemTools.getUserName();
        assertEquals("usr207", user);
    }

    @Test
    public void getComputerName() {
        String computer = SystemTools.getComputerName();
        assertEquals("PC119", computer);
    }

    @Test
    public void getHomeDirectory() {
        String computer = SystemTools.getHomeDirectory();
        assertEquals("C:\\Users\\setup", computer);
    }

    @Test
    public void getLocalhost() {
        String ip4Address = SystemTools.getLocalhost();
        assertEquals("192.168.30.119", ip4Address);
    }

}
