package de.duehl.math.graph.ged.animation.test;

import de.duehl.basics.datetime.Timestamp;
import de.duehl.basics.io.FileHelper;
import de.duehl.math.graph.ged.animation.WayFindAlgorithmGraph;

public class CreateWay {

    private WayFindAlgorithmGraph graph;

    public void create() {
        constructGraph();
        graph.markEdgeAsPartOfTheWay(0, 2);
        graph.markEdgeAsPartOfTheWay(2, 6);
        graph.markEdgeAsPartOfTheWay(6, 9);
    }

    private void constructGraph() {
        /*
         *  *  0 10 20 25 30 35 40 50
         *  0
         *  15       1-----4-----5
         *  30      /             \
         *  45     /               \
         *  60    0-----2-----6-----9
         *  75     \               /
         *  90      \             /
         * 105       3-----7-----8
         *
         */
        graph = new WayFindAlgorithmGraph();

        graph.addVertex(10,  60);  // 0
        graph.addVertex(20,  15);  // 1
        graph.addVertex(25,  60);  // 2
        graph.addVertex(20, 105);  // 3
        graph.addVertex(30,  15);  // 4
        graph.addVertex(40,  15);  // 5
        graph.addVertex(35,  60);  // 6
        graph.addVertex(30, 105);  // 7
        graph.addVertex(40, 105);  // 8
        graph.addVertex(50,  60);  // 9
        graph.addEdge(0, 1);
        graph.addEdge(0, 2);
        graph.addEdge(0, 3);
        graph.addEdge(1, 4);
        graph.addEdge(2, 6);
        graph.addEdge(3, 7);
        graph.addEdge(4, 5);
        graph.addEdge(6, 9);
        graph.addEdge(7, 8);
        graph.addEdge(5, 9);
        graph.addEdge(8, 9);

        graph.constructionCompleted();
    }

    public void saveAnimation(String filename) {
        graph.saveAnimation(filename);
    }

    public static void main(String[] args) {
        CreateWay create = new CreateWay();
        create.create();

        String directory = FileHelper.getAndPerhapsCreateDirectoryAtHome(".ged");
        String filename = "Animation_WayFindAlgorithm_" + Timestamp.fullTimestamp() + ".gedanim";
        filename = FileHelper.concatPathes(directory, filename);
        /*
         * Ich hab keine Ahnung mehr, wie das Format damals war...
         */
        create.saveAnimation(filename);
    }

}
