package de.duehl.math.graph.ged.graph.edge;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Diese Klasse stellt die Kanten eines Graphen dar.
 *
 * @version 1.01     2019-06-14
 * @author Christian Dühl
 */

public class Edges implements Iterable<Edge> {

    /** Kantenmenge */
    private final List<Edge> edges;

    public Edges() {
        edges = new ArrayList<>();
    }

    @Override
    public Iterator<Edge> iterator() {
        return edges.iterator();
    }

    public void add(Edge edge) {
        edges.add(edge);
    }

    public int size() {
        return edges.size();
    }

    public Edge get(int index) {
        return edges.get(index);
    }

    public boolean contains(Edge edge) {
        return edges.contains(edge);
    }

    public void remove(int index) {
        edges.remove(index);
    }

    public void remove(Edge edge) {
        edges.remove(edge);
    }

    /** Liefert die Liste mit den Kanten zurück. */
    public List<Edge> getEdges() { // TODO Verwendung vermeiden...
        return edges;
    }

    public void clear() {
        edges.clear();
    }

    public boolean isEmpty() {
        return edges.isEmpty();
    }

    public boolean containsExactObject(Edge edge) {
        for (Edge edgeInList : edges) {
            if (edge == edgeInList) {
                return true;
            }
        }

        return false;
    }

}
