package de.duehl.math.graph.ged.graph.io.ged4;

import de.duehl.basics.text.NumberString;

/**
 * Diese Klasse enthält Hilfsmethoden rund um das Laden und Speichern im ged4-Format zur Verfügung.
 *
 * @version 1.01     2019-06-19
 * @author Christian Dühl
 */

public class Ged4Helper {

    /** Diese Methode ist nur dafür dar, alte Dateien im ged4-Format zu retten... */
    public static String doubleToInt(String perhapsNumber) {
        return NumberString.removeZeroEnding(perhapsNumber);
        // Später wird die Methode unnötig sein! Schadet aber auch nicht.
    }

    /**
     * Ermittelt die Variable aus einem Teil einer Zeile.
     *
     * @param part
     *            Teil einer Zeile.
     * @param actualLine
     *            Gerade behandelte Zeile für Fehlerausgaben.
     * @param actualLineNumber
     *            Nummer der gerade behandelten Zeile für Fehlerausgaben.
     */
    public static Variable determineVariable(String part, String actualLine, int actualLineNumber) {
        try {
            return tryToDetermineVariable(part);
        }
        catch (Exception exception) {
            throw new RuntimeException("Fehler beim Laden in Zeile Nummer "
                    + actualLineNumber + "\n\t" + actualLine + "\tim ged4-Format!");
        }
    }

    private static Variable tryToDetermineVariable(String part) {
        return Variable.splitVariableByEqualsSign(part);
    }

    /** Verbirgt ; und = in den Labeln von Ecken und Kanten. */
    public static String hideUsedCharactersInLabel(String label) {
        String cleanedLabel = label;
        cleanedLabel = cleanedLabel.replace(";", ",");
        cleanedLabel = cleanedLabel.replace("=", "-");
        return cleanedLabel;
    }

}
