package de.duehl.math.graph.ged.ui.creation.gui;

import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.JPanel;

import de.duehl.math.graph.ged.ui.GuiElements;
import de.duehl.math.graph.ged.ui.elements.ModusActivator;
import de.duehl.math.graph.ged.ui.graphpanel.EditModus;

public abstract class GraphInsertEdgeModusButtonPanelCreator {

    protected final GuiElements elements;
    protected JPanel panel;
    protected GridBagConstraints gbc;

    public GraphInsertEdgeModusButtonPanelCreator(GuiElements elements) {
        this.elements = elements;

        gbc = new GridBagConstraints();
        gbc.insets     = new Insets(0, 0, 0, 0);
        gbc.fill       = GridBagConstraints.BOTH;
        gbc.anchor     = GridBagConstraints.NORTHWEST;
        gbc.weightx    = 0.0;
        gbc.weighty    = 0.0;
        gbc.gridx      = 0;
        gbc.gridy      = 0;

        panel = elements.getInsertEdgeModusButtonPanel();
    }

    public final void create() {
        createInternal();
        
        ModusActivator activator = new ModusActivator(elements);
        activator.activate(EditModus.ADD_VERTEX);

        panel.repaint();
    }

    protected abstract void createInternal();

}
