package de.duehl.math.graph.ged.ui.dialogs;

import java.awt.Image;
import java.awt.Point;

import de.duehl.math.graph.ged.graph.Graph;
import de.duehl.swing.ui.dialogs.ErrorDialog;

/**
 * Diese Klasse öffnet einen Dialog zur Anzeige eines Fehlers.
 *
 * @version 1.01     2019-05-24
 * @author Christian Dühl
 */

public class GraphErrorDialog extends ErrorDialog {

    private static final Graph NO_GRAPH = new Graph();

    private Graph graph;

    /** Konstruktor für Fehler die Auftreten, wenn man einen Graph darstellt. */
    public GraphErrorDialog(String message, Throwable exception, Graph graph, Image programImage,
            String logFileName, Point parentLocation) {
        super(message, exception, programImage, logFileName, parentLocation);
        this.graph = graph;
        /*
         * TODO sich gleich die Location übergeben lassen !!!
         */
    }

    /** Konstruktor für Fehler die Auftreten, bevor man einen Graph darstellt. */
    public GraphErrorDialog(String message, Throwable exception) {
        this(message, exception, NO_GRAPH, null, "", new Point(200, 100));
    }

    @Override
    protected void addToReport(StringBuilder builder) {
        builder.append("\n\nGraph:\n");
        if (NO_GRAPH == graph) {
            builder.append("no graph\n");
        }
        else {
            builder.append(graph.saveToGed4Format() + "\n");
        }
    }

    @Override
    protected String createPureReportFilenameSuggestionAddon() {
        if (NO_GRAPH == graph) {
            return "without_graph";
        }
        else {
            return "with_graph";
        }
    }

}
