package de.duehl.math.graph.ged.ui.elements;

import java.awt.Color;

import javax.swing.JFrame;

import de.duehl.math.graph.ged.graph.GedColor;
import de.duehl.math.graph.ged.ui.elements.color.ColorSetter;
import de.duehl.swing.ui.components.elements.HorizontalNumericTextFieldWithTitle;
import de.duehl.swing.ui.components.elements.TextFieldWithTitle;

/**
 * Diese Klasse stellt für den Ecken- und Kanten-Dialog Eingabefelder für einen numerischen Wert,
 * X- und Y-Abstand und eine Farbwahl mit Default-Schalter dar.
 *
 * @version 1.01     2019-05-27
 * @author Christian Dühl
 */

public class NumericValueDistanceAndColorChooser extends ValueDistanceAndColorChooser {

    /**
     * Konstruktor.
     *
     * @param titleOfValueInputField
     *            Text vor dem Eingabefeld für den Wert.
     * @param hasDefaultColor
     *            Gibt an, ob zu Beginn die Default-Farbe verwendet wird.
     * @param textForXDistance
     *            Text vor dem Eingabefeld zum Abstand in X-Richtung.
     * @param textForYDistance
     *            Text vor dem Eingabefeld zum Abstand in Y-Richtung.
     * @param textForToggleButton
     *            Text der auf der Checkbox zum an und Ausschalten des Default-Zustands angezeigt
     *            wird.
     * @param textForColorButtonTitle
     *            Text der als Titel vor dem Farbbutton angezeigt wird.
     * @param textForColorChooserDialogTitle
     *            Text der als Titel des Dialogs zur Farbauswahl angezeigt wird.
     * @param actualSwingColor
     *            Farbe des Objekts zum Zeitpunkt des Aufrufs.
     * @param defaultGedColor
     *            Default-Farbe des Objekts.
     * @param colorSetter
     *            Setzt die Farbe im Objekt.
     * @param frame
     *            Rahmen von GED zur relativen Positionierung des Farbauswahldialogs.
     */
    public NumericValueDistanceAndColorChooser(String titleOfValueInputField,
            boolean hasDefaultColor, String textForXDistance, String textForYDistance,
            String textForToggleButton, String textForColorButtonTitle,
            String textForColorChooserDialogTitle, Color actualSwingColor, GedColor defaultGedColor,
            ColorSetter colorSetter, JFrame frame) {
        super(titleOfValueInputField, hasDefaultColor, textForXDistance, textForYDistance,
                textForToggleButton, textForColorButtonTitle, textForColorChooserDialogTitle,
                actualSwingColor, defaultGedColor, colorSetter, frame);
    }

    @Override
    protected TextFieldWithTitle createValueField(String title) {
        return new HorizontalNumericTextFieldWithTitle(title);
    }

}
