#------------------------------------------------------------------------------
# Module      : T e s t . p m
#------------------------------------------------------------------------------
# Autor       : Christian Dühl
# Created     : 18. Januar 2005
# last change : 19. Januar 2005
# Task        : Test functions of GED
#------------------------------------------------------------------------------

package Graph::GED::Test;

use strict;
use warnings;

use Graph::GED::Core qw/$Graph/;
use Graph::GED::Historie;

#------------------------------------------------------------------------------
# Derive from Exporter:
#------------------------------------------------------------------------------
use base qw/Exporter/;
our @EXPORT_OK = qw/geom_test historie_test geom_test/;


#------------------------------------------------------------------------------
# Globale private Datei-Variablen:
#------------------------------------------------------------------------------
my $Debug = 0;


sub geom_test () {
    #--------------------------------------------------------------------------
    # sub          : g e o m _ t e s t
    #--------------------------------------------------------------------------
    # Autor        : Christian Dühl
    # Aufgabe      : Testet alles mögliche und hält dann an.
    # Parameter    : keine
    # Rückgabewert : keiner
    #--------------------------------------------------------------------------
    # 0.0.1 - 10.02.2003 - CD - Erstellt
    # 0.0.2 - 13.02.2003 - CD - Tests umgebrochen, so dass alles in die ersten
    #                           80 Zeichen passt.
    # 0.0.3 - 10.02.2004 - CD - Module in Namensraum Graph::GED verschoben.
    # 0.0.4 - 18.01.2005 - CD - Funktion nach Graph::GED::Test verschoben.
    #--------------------------------------------------------------------------

    #
    # floor
    #
    print "floor($_)=", Graph::GED::Geom::floor($_), "\n" for (1.4,566.2,0,-24,-55.1);

    #
    # punkt_abstand
    #
    my ($x1, $y1, $x2, $y2);
    $x1=0;  $y1=0;  $x2=10; $y2=0;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=10; $y1=0;  $x2=0;  $y2=0;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=0;  $y2=10; print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=10; $x2=0;  $y2=0;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";

    $x1=1;  $y1=0;  $x2=10; $y2=0;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=1;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=2;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=3;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=4;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=5;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=6;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=7;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=8;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=9;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";
    $x1=0;  $y1=0;  $x2=10; $y2=10; print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";

    $x1=2;  $y1=2;  $x2=3;  $y2=3;  print "Abstand ($x1,$y1)-($x2,$y2) = ",
                        Graph::GED::Geom::punkt_abstand($x1,$y1,$x2,$y2), "\n";

    #
    # abstand_punkt_linie
    #
    my ($x, $y, $ax, $ay, $bx, $by);

    $x=1; $y=1; $ax=0; $ay=0; $bx=2; $by=2;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    $x=2; $y=2; $ax=0; $ay=0; $bx=6; $by=6;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    # Murks, da es nur für ganze Zahlen geht:
    #$x=2.432; $y=2.432; $ax=0; $ay=0; $bx=6; $by=6;
    #print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
    #      Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    $x=2432; $y=2432; $ax=0; $ay=0; $bx=6000; $by=6000;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    $x=-1; $y=-1; $ax=0; $ay=0; $bx=-2; $by=-2;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";
    $x=-2; $y=-2; $ax=0; $ay=0; $bx=-6; $by=-6;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    $x=-1; $y=-1; $ax=-2; $ay=-2; $bx=0; $by=0;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";
    $x=-2; $y=-2; $ax=-6; $ay=-6; $bx=0; $by=0;
    print "Abstand ($x,$y) von ($ax,$ay)---($bx,$by) ist ",
          Graph::GED::Geom::abstand_punkt_linie($x,$y, $ax,$ay, $bx,$by), "\n\n";

    exit();
} # sub Graph::GED::Test::geom_test


sub clone_test () {
    #--------------------------------------------------------------------------
    # sub          : c l o n e _ t e s t
    #--------------------------------------------------------------------------
    # Autor        : Christian Dühl
    # Aufgabe      : Testet die Clone-Methoden.
    # Parameter    : keine
    # Rückgabewert : keiner
    #--------------------------------------------------------------------------
    # 0.0.1 - 11.02.2004 - CD - Erstellt
    # 0.0.2 - 18.01.2005 - CD - Testet auch Graph::GED::Animation.
    # 0.0.3 - 18.01.2005 - CD - Funktion nach Graph::GED::Test verschoben.
    #--------------------------------------------------------------------------

    $Graph->ecke_einfuegen(0,0); # 0
    $Graph->ecke_einfuegen(50,100); # 1
    $Graph->ecke_einfuegen(100,0); # 2
    $Graph->kante_einfuegen(0,1); # 0
    $Graph->kante_einfuegen(1,2); # 1

    use Data::Dumper;
    print "Graph: ", Dumper($Graph), "\n";

    my $neu = $Graph->new();
    print "Neu: ", Dumper($neu), "\n";

    my $clone = $Graph->clone();
    print "Clone: ", Dumper($clone), "\n";

    print "Graph          : ", $Graph                 , "\n",
          "Clone          : ", $clone                   , "\n",
          "Graphs Ecken   : ", $Graph->_ecken()       , "\n",
          "Clones Ecken   : ", $clone->_ecken()         , "\n",
          "Graphs Kanten  : ", $Graph->_kanten()      , "\n",
          "Clones Kanten  : ", $clone->_kanten()        , "\n",
          "Graphs 1. Ecke : ", @{$Graph->_ecken()}[0] , "\n",
          "Clones 1. Ecke : ", @{$clone->_ecken()}[0]   , "\n",
          "Graphs 1. Kante: ", @{$Graph->_kanten()}[0], "\n",
          "Clones 1. Kante: ", @{$clone->_kanten()}[0]  , "\n";


    print "\nANIMATION\n";
    my $ani = new Graph::GED::Animation;
    $ani->push($Graph);
    $ani->push($clone);
    print "Original Animation:\n", Dumper($ani);
    my $cloneani = $ani->clone();
    print "Geclonte Animation:\n", Dumper($cloneani);
    print "Animation      : ", $ani                       , "\n",
          "Clone Animation: ", $cloneani                  , "\n",
          "Ani Graphen    : ", $ani->_graphs()            , "\n",
          "C-Ani Graphen  : ", $cloneani->_graphs()       , "\n",
          "Ani 1. Graph   : ", @{$ani->_graphs()}[0]      , "\n",
          "C-Ani 1. Graph : ", @{$cloneani->_graphs()}[0] , "\n";

    exit();
} # sub Graph::GED::Test::clone_test


sub historie_test () {
    #--------------------------------------------------------------------------
    # sub          : h i s t o r i e _ t e s t
    #--------------------------------------------------------------------------
    # Autor        : Christian Dühl
    # Aufgabe      : Testet die Historien-Klasse.
    # Parameter    : keine
    # Rückgabewert : keiner
    #--------------------------------------------------------------------------
    # 0.0.1 - 12.02.2004 - CD - Erstellt
    # 0.0.2 - 18.01.2005 - CD - Funktion nach Graph::GED::Test verschoben.
    #--------------------------------------------------------------------------

    use Data::Dumper;

    my $Hist = new Graph::GED::Historie;
    print "1 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Hist->objekt_eintragen($Graph);
    print "2 - ::Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Graph->ecke_einfuegen(0,0);    # E 0
    $Graph->ecke_einfuegen(50,100); # E 1
    $Graph->ecke_einfuegen(100,0);  # E 2
    $Graph->kante_einfuegen(0,1);   # K 0
    $Graph->kante_einfuegen(1,2);   # K 1
    print "3 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Hist->objekt_eintragen($Graph);
    print "4 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Graph->clear();
    $Graph = undef;
    ($Graph, undef, undef) = $Hist->rueckgaengig();
    print "5 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Graph->clear();
    $Graph = undef;
    ($Graph, undef, undef) = $Hist->wiederholung();
    print "6 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);


    $Graph->ecke_loeschen(1);
    $Hist->objekt_eintragen($Graph);
    print "7 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    $Graph->ecke_loeschen(1);
    $Hist->objekt_eintragen($Graph);
    print "8 - Graph=$Graph - ", Dumper($Graph);
    print "Hist: ", Dumper($Hist);

    exit();
} # sub Graph::GED::Test::historie_test


1;


__END__

=head1 NAME

Graph::GED::Test.pm - a module with the test functions of GED

=head1 FUNCTIONS

=over

=item C<geom_test>

    Do the geometry test.

=item C<clone_test>

    Do the clone test.

=item C<historie_test>

    Do the history test.

=back

=head1 COPYRIGHT

Copyright 2005 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
