#!/usr/bin/perl
use strict;
use warnings;

use File::Copy;

use FindBin;
use lib $FindBin::RealBin;

use DevTools qw/get_version/;
use Archive::Zip;
use Archive::Zip::Tree;

#------------------------------------------------------------------------------
# Version ermitteln:
#------------------------------------------------------------------------------
my ($version, $datum) = get_version("$FindBin::RealBin/../Graph/GED/Core.pm");
#print "Version: $version vom $datum\n";
my $dir = "ged_$version";


#------------------------------------------------------------------------------
# Verzeichnis löschen:
#------------------------------------------------------------------------------
if (-d $dir) {
    unless (eval { qx(rm -r $dir 2>&1) } ) {
        print "$dir deleted (via rm -r).\n";
    }
    else {
        unless (eval { qx(rmdir /S /Q $dir 2>&1) } ) {
            print "$dir deleted (via rmdir /S /Q).\n";
        }
    }
}

#------------------------------------------------------------------------------
# Verzeichnisse anlegen:
#------------------------------------------------------------------------------
mkdir $dir;
mkdir "$dir/data";       # bleibt leer
mkdir "$dir/Graph";
mkdir "$dir/Graph/GED";
mkdir "$dir/hilfe";
mkdir "$dir/res";
mkdir "$dir/devtools";

#------------------------------------------------------------------------------
# ged.pl kopieren:
#------------------------------------------------------------------------------
copy("$FindBin::RealBin/../ged.pl", $dir);

#------------------------------------------------------------------------------
# Klassen aus Graph::GED kopieren:
#------------------------------------------------------------------------------
for my $file (<$FindBin::RealBin/../Graph/GED/*>) {
    #print "File $file\n";
    copy($file, "$dir/Graph/GED");
}

#------------------------------------------------------------------------------
# Hilfe kopieren:
#------------------------------------------------------------------------------
for my $file (<$FindBin::RealBin/../hilfe/*>) {
    #print "File $file\n";
    copy($file, "$dir/hilfe");
}

#------------------------------------------------------------------------------
# Resourcen kopieren:
#------------------------------------------------------------------------------
for my $file (<$FindBin::RealBin/../res/*>) {
    #print "File $file\n";
    copy($file, "$dir/res");
}

#------------------------------------------------------------------------------
# Entwicklungstools kopieren:
#------------------------------------------------------------------------------
for my $file (<$FindBin::RealBin/../devtools/*>) {
    #print "File $file\n";
    copy($file, "$dir/devtools");
}

print "$dir created.\n";




#------------------------------------------------------------------------------
# Erzeugte Verzeichnis packen:
#------------------------------------------------------------------------------
my $zip = new Archive::Zip;
$zip->addTree($dir, $dir);
$zip->writeToFileNamed("$dir.zip");

print "$dir.zip created.\n";
