package de.duehl.math.geometry;

/*
 * Copyright 2016 Christian Dühl. All rights reserved.
 *
 * This program is free software. You can redistribute it and/or
 * modify it under the same terms as perl:
 *
 * general:  http://dev.perl.org/licenses/
 * GPL:      http://dev.perl.org/licenses/gpl1.html
 * artistic: http://dev.perl.org/licenses/artistic.html
 */

import static org.junit.Assert.*;

import org.junit.Test;

import de.duehl.math.geometry.Point;

public class PointTest {

    @Test
    public void create1() {
        assertNotNull(new Point());
    }

    @Test
    public void create2() {
        assertNotNull(new Point(3.2, 5.3));
    }

    @Test
    public void createDefaultAndXIsZero() {
        Point point = new Point();
        double x = point.getX();
        assertTrue(0.0 == x);
    }

    @Test
    public void createDefaultAndYIsZero() {
        Point point = new Point();
        double y = point.getY();
        assertTrue(0.0 == y);
    }

    @Test
    public void setX() {
        Point point = new Point();
        double expected = 15.73;
        point.setX(expected);
        double actual = point.getX();
        assertTrue(expected == actual);
    }

    @Test
    public void setY() {
        Point point = new Point();
        double expected = 15.73;
        point.setY(expected);
        double actual = point.getY();
        assertTrue(expected == actual);
    }

    @Test
    public void getXAsInteger1() {
        Point point = new Point(15.73, 17.27);
        int expected = 16;
        int actual = point.getXAsInteger();
        assertTrue(expected == actual);
    }

    @Test
    public void getYAsInteger1() {
        Point point = new Point(15.73, 17.27);
        int expected = 17;
        int actual = point.getYAsInteger();
        assertTrue(expected == actual);
    }

    @Test
    public void equals1() {
        Point point1 = new Point(15.73, 17.27);
        Point point2 = new Point(15.73, 17.27);
        assertEquals(point1, point2);
    }

    @Test
    public void equals2() {
        Point point1 = new Point(15.73001, 17.27);
        Point point2 = new Point(15.73002, 17.27);
        // wegen epsilon = 0.001 gleich
        assertEquals(point1, point2);
    }

}
